#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ExchangeCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ExchangeCFG> M_ExchangeCFG::msSingleton(nullptr);

int M_ExchangeCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ExchangeCFGData* M_ExchangeCFG::GetData(int ChangeId)
{
	auto it = mMapData.find(ChangeId);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ExchangeCFGData>& M_ExchangeCFG::GetMapData()
{
	return mMapData;
}

void M_ExchangeCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ExchangeCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ExchangeCFGData data;
		data.mChangeId = element->IntAttribute("ChangeId");
		data.mFunction = element->IntAttribute("Function");
		data.moder = element->IntAttribute("oder");
		data.mItemName = element->Attribute("ItemName");
		data.mItemDesc = element->Attribute("ItemDesc");
		data.mVipCondition = element->IntAttribute("VipCondition");
		data.mExchangeType = element->IntAttribute("ExchangeType");
		{
			const char* NeedItemId = element->Attribute("NeedItemId");
			std::vector<std::string> vecNeedItemId;
			boost::split(vecNeedItemId, NeedItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNeedItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNeedItemId[i].c_str(), &temp))
				{
					data.mNeedItemId.push_back(temp);
				}
			}
		}
		{
			const char* NeedItemCount = element->Attribute("NeedItemCount");
			std::vector<std::string> vecNeedItemCount;
			boost::split(vecNeedItemCount, NeedItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecNeedItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecNeedItemCount[i].c_str(), &temp))
				{
					data.mNeedItemCount.push_back(temp);
				}
			}
		}
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		data.mIcon = element->Attribute("Icon");
		data.mTimeType = element->IntAttribute("TimeType");
		data.mExchangeMaxLimit = element->IntAttribute("ExchangeMaxLimit");
		data.mType = element->IntAttribute("Type");
		data.mManageMent = element->IntAttribute("ManageMent");
		data.mManageMentName = element->Attribute("ManageMentName");
		data.mDiscount = element->IntAttribute("Discount");
		data.mReturnContribution = element->IntAttribute("ReturnContribution");
		if (mMapData.find(data.mChangeId) != mMapData.end())std::cout <<"data refind:" << data.mChangeId << std::endl;
		assert(mMapData.find(data.mChangeId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mChangeId, data));
		element = element->NextSiblingElement();
	}
}

void M_ExchangeCFG::Load()
{
	Load("../Config/M_ExchangeCFG.xml");
}

M_ExchangeCFG* M_ExchangeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ExchangeCFG());
	}
	return msSingleton.get();
}
